//----------------------------------------------------------------------------
/// @file token.hpp
/// @brief Insertion Sort algorithm
///
/// @author Copyright (c) 2010 Francisco José Tapia (fjtapia@gmail.com )\n
///         Distributed under the Boost Software License, Version 1.0.\n
///         ( See accompanyingfile LICENSE_1_0.txt or copy at
///           http://www.boost.org/LICENSE_1_0.txt  )
/// @version 0.1
///
/// @remarks
//-----------------------------------------------------------------------------
#ifndef __CNTREE_SORT_TOKEN_HPP
#define __CNTREE_SORT_TOKEN_HPP


namespace boost
{
namespace countertree
{
namespace util
{
namespace sort
{


template <class iter_t>
struct token
{   //----------- variables -------------
    iter_t first ;
    iter_t last ;
    //------------------- Functions -------------------
    token( void){} ;
    token ( iter_t it_f , iter_t it_l):first ( it_f), last ( it_l){};
};

template <class iter_t>
struct token_level
{   //----------- variables -------------
    iter_t first ;
    iter_t last ;
    int32_t level ;
    //------------------- Functions -------------------
    token_level( void){} ;
    token_level ( iter_t it_f, iter_t it_l, int32_t lv)
                 :first (it_f),last(it_l),level(lv) {  };
};
//
//****************************************************************************
};//    End namespace sort
};//    End namespace util
};//    End namespace countertree
};//    End namespace boost
//****************************************************************************
//
#endif
