//----------------------------------------------------------------------------
/// @file parallel_basics.hpp
/// @brief Basic functions definitions and data structures for the parallel process
/// @author Copyright (c) 2010 Francisco José Tapia (fjtapia@gmail.com )\n
///         Distributed under the Boost Software License, Version 1.0.\n
///         ( See accompanyingfile LICENSE_1_0.txt or copy at
///           http://www.boost.org/LICENSE_1_0.txt  )
/// @version 0.1
///
/// @remarks
//-----------------------------------------------------------------------------
#ifndef __CNTREE_SORT_BASICS_HPP
#define __CNTREE_SORT_BASICS_HPP

#include <boost/countertree/util/sort/basics.hpp>
#include <boost/countertree/util/stack_cnc.hpp>

namespace boost
{
namespace countertree
{
namespace util
{
namespace sort
{

//---------------------------------------------------------------------------
//                     using sentences
//---------------------------------------------------------------------------
using cntree::util::MAX64 ;
using cntree::util::MAX32 ;
using cntree::util::MAX ;

using cntree::util::size_type ;
using cntree::util::difference_type ;

using cntree::util::unsigned_type ;
using cntree::util::signed_type ;

using cntree::util::n_bits_max  ;

using cntree::util::NBits ;
using cntree::util::MS1B ;

using  cntree::util::parallel::atomic_read ;
using  cntree::util::parallel::atomic_add ;
using cntree::util::parallel::atomic_sub ;

using cntree::util::iter_value;

using cntree::util::parallel::NThread;
using cntree::util::parallel::stack_cnc ;
//
//****************************************************************************
};//    End namespace sort
};//    End namespace util
};//    End namespace countertree
};//    End namespace boost
//****************************************************************************
//
#endif


