//----------------------------------------------------------------------------
/// @file sort.hpp
/// @brief This file contains the sort functions of the countertree library
///
/// @author Copyright (c) 2010 Francisco José Tapia (fjtapia@gmail.com )\n
///         Distributed under the Boost Software License, Version 1.0.\n
///         ( See accompanyingfile LICENSE_1_0.txt or copy at
///           http://www.boost.org/LICENSE_1_0.txt  )
/// @version 0.1
///
/// @remarks
//-----------------------------------------------------------------------------
#ifndef __CNTREE_SORT_HPP
#define __CNTREE_SORT_HPP

#include <boost/countertree/util/algorithm.hpp>
#include <boost/countertree/util/sort/insertion_sort.hpp>
#include <boost/countertree/util/sort/selection_sort.hpp>
#include <boost/countertree/util/sort/heap_sort.hpp>
#include <boost/countertree/util/sort/quick_sort.hpp>
#include <boost/countertree/util/sort/quick_sort_nr.hpp>
#include <boost/countertree/util/sort/intro_sort.hpp>
#include <boost/countertree/util/sort/parallel_sort.hpp>
#include <boost/countertree/util/sort/merge_sort.hpp>
#include <boost/countertree/util/sort/merge_sort_pos.hpp>
#include <boost/countertree/util/sort/parallel_merge_sort.hpp>
#include <boost/countertree/util/sort/quick_stable_sort.hpp>
#include <boost/countertree/util/util_iterator.hpp>

#include <thread>

namespace boost
{
namespace countertree
{


using boost::countertree::util::sort::insertion_sort ;
using boost::countertree::util::sort::selection_sort ;
using boost::countertree::util::sort::heap_sort ;
using boost::countertree::util::sort::quick_sort ;
using boost::countertree::util::sort::quick_sort_nr ;
using boost::countertree::util::sort::intro_sort ;
using boost::countertree::util::sort::indirect_intro_sort ;
using boost::countertree::util::sort::sort ;
using boost::countertree::util::sort::indirect_sort ;
using boost::countertree::util::sort::merge_sort ;
using boost::countertree::util::sort::indirect_merge_sort ;
//using boost::countertree::util::sort::merge_sort_pos ;
using boost::countertree::util::sort::stable_sort ;
using boost::countertree::util::sort::indirect_stable_sort ;
using boost::countertree::util::sort::parallel_sort ;
using boost::countertree::util::sort::indirect_parallel_sort ;
using boost::countertree::util::sort::parallel_merge_sort ;
using boost::countertree::util::sort::indirect_parallel_merge_sort ;
using boost::countertree::util::sort::parallel_stable_sort ;
using boost::countertree::util::sort::indirect_parallel_stable_sort ;
using boost::countertree::util::sort::quick_stable_sort ;
using boost::countertree::util::sort::NThread ;
using boost::countertree::util::less_ptr ;
using boost::countertree::util::less_ptr_no_null ;

//
//****************************************************************************
};//    End namespace countertree
};//    End namespace boost
//****************************************************************************
//
#endif
